/*****************************************************************
 *
 * Copyright (c) 2000 Mount Linux Inc.
 *
 * nmSourceBuild.h
 *
 * Receive the package name from a client and use that to locate a
 * package to build.
 *
 *****************************************************************/

#ifndef __nmSourceBuild_h_
#define __nmSourceBuild_h_

#include "nmProcess.h"
//#include "processmanager.h"

class processManager;

class nmSourceBuild: public nmProcess
{
public:
    nmSourceBuild(transport* socket, unsigned int sessID, unsigned int commID);
    ~nmSourceBuild();
    int activate();
    int activate(processManager* pm);
    processManager* newProcess();
    void prepareToSend();

private:
    char* file;                 // actual tar file name
    char* pkgname;              // name of package; used to name directory
    char* options;              // options to give to make
    char* tmpFilePath;          // path to output from build process
    int processStatus;          // return from build process
    int seconds;                // processing time
    int useconds;               // remainder in microseconds
};

#endif __nmSourceBuild_h_
